package seu.agent.Ambulance;

import java.util.EnumSet;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Civilian;
import rescuecore2.standard.entities.StandardEntityURN;
import rescuecore2.worldmodel.EntityID;
import seu.agent.SEUCentre;
import seu.message.Type.BuildingIsExploredMessage;
import seu.message.Type.CivilianInformationMessage;
import seu.message.Type.InformTeamSavingCivilianMessage;
import seu.message.Type.Message;
import seu.object.SEUWorldModel;

public class SEUAmbulanceCentre extends SEUCentre {

	CivilianSaveTaskManager civilianSaveTaskManager;

	public SEUAmbulanceCentre() {
		super();
	}

	@Override
	public String toString() {
		return "SEU Ambulance Center";
	}

	@Override
	protected void postConnect() {
		super.postConnect();

		this.world = (SEUWorldModel) super.model;

		world.indexClass(StandardEntityURN.BUILDING, StandardEntityURN.REFUGE);

		civilianSaveTaskManager = new CivilianSaveTaskManager(world);
	}

	@Override
	protected void thinkAndAct() {

	}

	@Override
	protected void processMessage(Message message) {
		if (message instanceof BuildingIsExploredMessage) {
			BuildingIsExploredMessage explorationMessage = (BuildingIsExploredMessage) message;
			processExplorationMessage(explorationMessage);
		}
		if (message instanceof CivilianInformationMessage) {
			CivilianInformationMessage civilianInformationMessage = (CivilianInformationMessage) message;
			processCivilianInformationMessage(civilianInformationMessage);
		}
		if (message instanceof InformTeamSavingCivilianMessage) {
			InformTeamSavingCivilianMessage informTeamSavingCivilianMessage = (InformTeamSavingCivilianMessage) message;
			processInformTeamSavingCivilianMessage(informTeamSavingCivilianMessage);
		}
	}

	protected void processCivilianInformationMessage(
			CivilianInformationMessage message) {
		// LOG.info(me() + " received civilianinformationmessage " + message);
		// System.out.println(me() + " received civilianinformationmessage " +
		// message);
		Building civilianLocation = (Building) world.getEntity(new EntityID(
				message.getLocationId()));
		Civilian civilian = (Civilian) world.getEntity(new EntityID(message
				.getCivilianId()));
		civilian.setHP(message.getHp());
		civilian.setDamage(message.getDamage());
		civilian.setBuriedness(message.getBuriedness());
		civilianSaveTaskManager.addBuriedCivilian(civilian, civilianLocation);
	}

	protected void processInformTeamSavingCivilianMessage(
			InformTeamSavingCivilianMessage message) {
		// LOG.info(me() + " received InformTeamSavingCivilianMessage " +
		// message);
		// System.out.println(me() +
		// " received InformTeamSavingCivilianMessage " + message);
	}

	protected EnumSet<StandardEntityURN> getRequestedEntityURNsEnum() {
		return EnumSet.of(StandardEntityURN.AMBULANCE_CENTRE);
	}
}
