package seu.agent.BasicTask;

import rescuecore2.worldmodel.EntityID;
import seu.message.Type.ClearPathReason;

@SuppressWarnings("serial")
public class ClearPath extends Task {
	EntityID roadIdStart;
	EntityID roadIdFinish;
	boolean hasBeenAtStart;
	ClearPathReason clearPathReason;
	boolean isCompleted;

	/**
	 * Construct a ClearPathTask task.
	 * 
	 * @param RoadIdStart
	 * @param RoadIdFinish
	 * @param PathToClear
	 */
	public ClearPath(EntityID RoadIdStart, EntityID RoadIdFinish,
			ClearPathReason clearPathReason) {
		setRoadIds(RoadIdStart, RoadIdFinish);
		this.clearPathReason = clearPathReason;
		hasBeenAtStart = false;
		isCompleted = false;
	}

	public EntityID getRoadIdStart() {
		return roadIdStart;
	}

	public EntityID getRoadIdFinish() {
		return roadIdFinish;
	}

	public ClearPathReason getClearPathReason() {
		return clearPathReason;
	}

	public boolean hasBeenAtStart() {
		return hasBeenAtStart;
	}

	public void setHasBeenAtStart(boolean HasBeenAtStart) {
		hasBeenAtStart = HasBeenAtStart;
	}

	public boolean isCompleted() {
		return isCompleted;
	}

	public void setIsCompleted(boolean isCompleted) {
		this.isCompleted = isCompleted;
	}

	public void setRoadIds(EntityID RoadIdStart, EntityID RoadIdFinish) {
		this.roadIdStart = RoadIdStart;
		this.roadIdFinish = RoadIdFinish;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final ClearPath other = (ClearPath) obj;
		if (this.roadIdStart != other.roadIdStart
				&& (this.roadIdStart == null || !this.roadIdStart
						.equals(other.roadIdStart))) {
			return false;
		}
		if (this.roadIdFinish != other.roadIdFinish
				&& (this.roadIdFinish == null || !this.roadIdFinish
						.equals(other.roadIdFinish))) {
			return false;
		}
		return true;
	}

	@Override
	public int hashCode() {
		int hash = 5;
		hash = 79 * hash
				+ (this.roadIdStart != null ? this.roadIdStart.hashCode() : 0);
		hash = 79
				* hash
				+ (this.roadIdFinish != null ? this.roadIdFinish.hashCode() : 0);
		return hash;
	}

	/**
	 * Checks whether the given object is equal to itself or not
	 * 
	 * @param obj
	 *            Given object
	 * @return Returns true if objects are equal.
	 */

	@Override
	public State getState() {
		return State.ClearingPath;
	}
}
