package seu.agent.BasicTask;

import java.util.Comparator;

public class ClearPathTaskComparator implements Comparator<ClearPath> {
	/**
	 * Compares the given QueueMessages according to importance level.
	 * 
	 * @param x
	 *            The first message to compare
	 * @param y
	 *            The second message to compare
	 * @return Returns an 1 or -1 accroding to importance level of the messages.
	 */
	@Override
	public int compare(ClearPath x, ClearPath y) {
		if (x.getClearPathReason().ordinal() < y.getClearPathReason().ordinal()) {
			return -1;
		}
		if (x.getClearPathReason().ordinal() > y.getClearPathReason().ordinal()) {
			return 1;
		}
		return 0;
	}
}
