package seu.agent.BasicTask;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import rescuecore2.standard.entities.Building;
import seu.agent.Firebrigade.SEUFireBrigade;
import seu.object.Building.BurningBuildingComparator;

public class ExtinguishDangerousBuildingTask extends BasicTask<SEUFireBrigade> {

	Building building;

	public ExtinguishDangerousBuildingTask(SEUFireBrigade agent) {
		super(agent);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		SEUFireBrigade fb;
		Building building;
		fb = getFireAgent();
		building = getNextBuilding();
		if (building != null && fb.canExtinguish(building)) {
			this.building = building;
			state = State.Extinguishing;
			return true;
		}
		return false;
	}

	@Override
	public void execute() {
		if (state == State.Extinguishing) {
			getFireAgent().sendExtinguish(building);
		}
	}

	public SEUFireBrigade getFireAgent() {
		return (SEUFireBrigade) agent;
	}

	private Building getNextBuilding() {
		List<Building> heating;
		List<Building> buildings;
		BurningBuildingComparator comperator;

		heating = agent.getHeatingBuildings();
		if (heating.isEmpty()) {
			return null;
		} else {
			buildings = new ArrayList<Building>(heating);
			comperator = new BurningBuildingComparator(getModel(),
					agent.getTimeStep());
			Collections.sort(buildings, comperator);
			return buildings.get(0);
		}
	}
}
