package seu.agent.BasicTask;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Refuge;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.Firebrigade.SEUFireBrigade;

public class ExtinguishFromRefugeTask extends BasicTask<SEUFireBrigade> {

	Building building;

	public ExtinguishFromRefugeTask(SEUFireBrigade agent) {
		super(agent);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		boolean onRefuge;

		onRefuge = isOnRefuge();
		if (!onRefuge) {
			state = State.Inactive;
			return false;
		}

		SEUFireBrigade fb;
		Building building;
		fb = getFireAgent();
		building = fb.nextNearBuildingToExtinguish();
		if (building != null && building.isOnFire()
				&& fb.canExtinguish(building)) {
			this.building = building;
			state = State.Extinguishing;
			return true;
		}
		return false;
	}

	@Override
	public void execute() {
		if (state == State.Extinguishing) {
			getFireAgent().sendExtinguish(building);
		}
	}

	public SEUFireBrigade getFireAgent() {
		return (SEUFireBrigade) agent;
	}

	private boolean isOnRefuge() {
		StandardEntity position;
		boolean onRefuge;

		position = agent.getMeAsHuman().getPosition(getModel());
		onRefuge = (position instanceof Refuge);
		return onRefuge;
	}

}
