package seu.agent.BasicTask;

import rescuecore2.standard.entities.Building;
import seu.agent.Firebrigade.SEUFireBrigade;

public class ExtinguishNearFireTask extends BasicTask<SEUFireBrigade> {

	Building building;

	public ExtinguishNearFireTask(SEUFireBrigade agent) {
		super(agent);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		SEUFireBrigade fb;
		Building building;
		fb = getFireAgent();
		building = getFireAgent().nextNearBuildingToExtinguish();
		if (building != null && building.isOnFire()
				&& fb.canExtinguish(building)) {
			this.building = building;
			state = State.Extinguishing;
			return true;
		}
		return false;
	}

	@Override
	public void execute() {
		if (state == State.Extinguishing) {
			getFireAgent().sendExtinguish(building);
		}
	}

	public SEUFireBrigade getFireAgent() {
		return (SEUFireBrigade) agent;
	}

}
