package seu.agent.BasicTask;

import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class PartitionExplorationTask extends
		BasicTask<SEUAgent<? extends StandardEntity>> {
	Queue<Road> roads;
	Path path;
	Road road;

	public PartitionExplorationTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		StandardEntity location;

		setRoadsIfNotSet();
		if (roads == null) {
			return false;
		}

		location = agent.location();
		if (location.equals(road)) {
			road = null;
		}
		if (road == null) {
			if (!roads.isEmpty()) {
				road = roads.poll();
				roads.add(road);
			} else {
			}
		}
		if (road != null) {
			Path path;

			path = getSearch().getPath(agent.getMeAsHuman(), road,
					PathType.EmptyAndSafe);
			if (path != null && path.isPassable()) {
				this.path = path;
				state = State.Exploring;
				return true;
			} else {
				road = null;
				return false;
			}
		}
		return false;
	}

	@Override
	public void execute() {
		if (state == State.Exploring) {
			agent.sendMove(path);
		}
	}

	protected void setRoadsIfNotSet() {
		List<Road> rd;

		if (roads != null) {
			return;
		}

		rd = agent.getRoadsInPartition();
		if (rd != null && !rd.isEmpty()) {
			roads = new LinkedList<Road>();
			roads.addAll(rd);
		}
	}

}
