package seu.agent.BasicTask;

import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.message.MessagePriority;
import seu.message.Type.ClearPathIsNeededMessage;
import seu.message.Type.ClearPathReason;
import seu.utilities.Path;
import seu.utilities.Search.Cost.PathType;

public class SaveMyselfTask extends
		BasicTask<SEUAgent<? extends StandardEntity>> {
	private static final int MIN_DAMAGE_GO_TO_REFUGE = 1;
	Path path;

	public SaveMyselfTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
	}

	@Override
	public boolean shouldExecute() {
		if ((state == State.Inactive || state == State.SavingMyself)
				&& shouldGoToRefuge()) {
			Path path;
			path = agent.getPathToRefuge();
			// if (35380 == agent.getID().getValue())
			// System.err.println("1" + path);
			if (path != null && path.isPassable()) {
				this.path = path;
				state = State.SavingMyself;
				return true;
			} else if (path.hasInfiniteCost()) {
				path = agent.getPathToRefuge(PathType.Shortest);
				// if (35380 == agent.getID().getValue())
				// System.err.println("2" + path);
				if (path != null && path.isPassable()) {
					ClearPathIsNeededMessage message = new ClearPathIsNeededMessage(
							path.getStart(), path.getDestination(),
							ClearPathReason.SaveMySelf);
					agent.sendMessage(message, MessagePriority.High);
				}
			}
		}

		// System.err.println("No Path Found in " + agent.getTimeStep());

		return false;
	}

	@Override
	public void execute() {
		agent.sendMove(path);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
		path = null;
	}

	public boolean shouldGoToRefuge() {
		Human me = agent.getMeAsHuman();
		if (me.isDamageDefined()) {
			return me.getDamage() > MIN_DAMAGE_GO_TO_REFUGE;
		}
		return false;
	}
}
