package seu.agent.BasicTask;

import rescuecore2.standard.entities.StandardEntity;
import seu.agent.SEUAgent;
import seu.utilities.Path;

public class StayInPartitionTask extends
		BasicTask<SEUAgent<? extends StandardEntity>> {

	Path path;

	public StayInPartitionTask(SEUAgent<? extends StandardEntity> agent) {
		super(agent);
	}

	@Override
	public void taskDone() {
		state = State.Inactive;
	}

	@Override
	public boolean shouldExecute() {
		StandardEntity location;

		location = agent.location();
		if (!agent.isInMyPartition(location)) {
			Path path;

			path = agent.getPathToPartition();
			if (path != null && !path.isEmpty() && !path.hasInfiniteCost()) {

				this.path = path;
				state = State.MovingToPartition;
				return true;
			}
		}
		return false;
	}

	@Override
	public void execute() {
		if (state == State.MovingToPartition) {
			agent.sendMove(path);
		}
	}

}
