package seu.agent.Path;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.worldmodel.EntityID;
import seu.agent.Police.PoliceTaskPriority;
import seu.message.Type.InformTeamExtinguishingFireMessage;
import seu.message.Type.TrackedExtinguishingFireMessage;
import seu.object.SEUWorldModel;

public class FireBrigadePathManager {
	private List<TrackedExtinguishingFireMessage> trackedMessages;
	private List<RequiredClearPath> requiredClearPaths;

	public FireBrigadePathManager() {
		trackedMessages = new ArrayList<TrackedExtinguishingFireMessage>();
		requiredClearPaths = new ArrayList<RequiredClearPath>();
	}

	public void addMessage(InformTeamExtinguishingFireMessage message,
			int timeStep) {
		TrackedExtinguishingFireMessage tmessage = new TrackedExtinguishingFireMessage(
				message, null, timeStep);
		trackedMessages.add(tmessage);
	}

	public void updateState(SEUWorldModel world, int timeStep) {
		requiredClearPaths.clear();
		for (TrackedExtinguishingFireMessage next : trackedMessages) {

			EntityID start = next.getMessage().getBuildingId();
			int durationToClear = 0;
			RequiredClearPath requiredPath = new RequiredClearPath(start, null,
					durationToClear, PoliceTaskPriority.Ignore);
			requiredClearPaths.add(requiredPath);
		}
		clearTrackedMessage(timeStep);

	}

	public List<RequiredClearPath> getDesiredPaths() {
		return requiredClearPaths;
	}

	private void clearTrackedMessage(int timeStep) {
		trackedMessages.clear();
	}

}
