package seu.message.Type;

import java.util.ArrayList;
import java.util.List;

import seu.agent.BasicTask.State;
import seu.message.Property.IntegerProperty;
import seu.message.Property.MessageProperty;
import seu.message.Property.PropertyName;

public class StateInformationMessage extends Message {

	public StateInformationMessage() {
		super();
	}

	public StateInformationMessage(State state) {
		this();
		setState(state);
	}

	@Override
	protected List<MessageProperty<?>> createProperties() {
		List<MessageProperty<?>> properties = new ArrayList<MessageProperty<?>>();
		properties.add(new IntegerProperty(PropertyName.State, 1));
		return properties;
	}

	@Override
	public MessageType getType() {
		return MessageType.StateInformationMessage;
	}

	public void setState(State state) {
		setEnum(PropertyName.State, state);
	}

	public State getState() {
		return getEnum(PropertyName.State, State.values());
	}

}
