package seu.utilities;

import java.util.Comparator;

import rescuecore2.standard.entities.StandardEntity;

/**
 * 将所有智能体和参考点进行比较，按照ID大小进行排序
 */
public class IDComparator implements Comparator<StandardEntity> {

	/**
	 * Create an IDSorter.
	 */
	public IDComparator() {
	}

	/**
	 * Compares the standard entites according to ids.
	 * 
	 * @param a
	 *            First StandardEntity to compare
	 * @param b
	 *            Second StandardEntity to compare
	 * @return The difference between ids..
	 */
	@Override
	public int compare(StandardEntity a, StandardEntity b) {
		int id1 = a.getID().getValue();
		int id2 = b.getID().getValue();
		return id1 - id2;
	}
}